#include "X-sok.h"
#include "bruteforce.h"


#define N	32	/* number of rectangles */
#define M	128	/* size */
#define ADDENTER(i, j)	{ nextenter[(i)+1] = firstenter[j]; \
			  firstenter[j] = (i)+1; }
#define ADDLEAVE(i, j)	{ nextleave[(i)+1] = firstleave[j]; \
			  firstleave[j] = (i)+1; }

static void printlist(const char *msg, int y, int ind, int *next) {
    if (ind) {
	printf("%sing at y=%d:", msg, y);
	do {
	    printf(" %d", ind);
	} while ((ind = next[ind]));
	printf("\n");
    }
}

static void try_recursive(int i) {
    int ii, x, y;
    int nextenter[N], nextleave[N], firstenter[M], firstleave[M];
    int X[M];
    memset(X, 0, P.t[0].width*sizeof(int));
    memset(firstenter, 0, P.t[0].height*sizeof(int));
    memset(firstleave, 0, P.t[0].height*sizeof(int));
    for (ii = 0; ii < i; ++ii) {
	int pos = arr[ii].cy-arr[i].h+1;
	/* printf("Checking %d at enterpos %d\n", ii, pos); */
	if (pos < 0) {
	    ADDENTER(ii, 0);
	} else {
	    ADDENTER(ii, pos);
	}
	if (arr[ii].cy+arr[ii].h < P.t[0].height)
	    ADDLEAVE(ii, arr[ii].cy+arr[ii].h);
    }
    for (y = 0; y <= arr[i].my; ++y) {
	/* first, update X */
#if 0
	printlist("Leave",  y, firstleave[y], nextleave);
	printlist("Enter",  y, firstenter[y], nextenter);
#endif
	for (ii = firstleave[y]; ii; ii = nextleave[ii])
	    for (x = 0; x < arr[ii-1].w; ++x)
		--X[arr[ii-1].cx+x];
	for (ii = firstenter[y]; ii; ii = nextenter[ii])
	    for (x = 0; x < arr[ii-1].w; ++x)
		++X[arr[ii-1].cx+x];

	/* now check remaining positions */
	for (x = 0; x <= arr[i].mx; ++x) {
	    /* test intersection with previous rectangles */
	    for (ii = arr[i].w; ii; --ii) {
		if (X[x])
		    goto cannot_place_here;
		++x;
	    }
	    /* ii = 0: tile may be placed at x-arr[i].w */
	    /* place tile! */
	    arr[i].cy = y;
	new_position:
	    arr[i].cx = x-arr[i].w;
	    /* printf("Placing %d at (%2d,%2d)\n", i+1,  arr[i].cx,  arr[i].cy); */
	    if (i+1 >= widest+improvement) {
		widest = i+1;
		update(i+1);
	    }
	    if (i+1 == P.totaltiles) {
		/* found the solution */
		/* longjump! */
		longjmp(jbuf, 1);
	    } else
		try_recursive(i+1);
	    if (x < P.t[0].width && !X[x]) {
		/* tile may be placed at x+1-arr[i].w */
		++x;
		goto new_position;
	    }
	cannot_place_here:
	} /* for x */
    } /* for y */
}

void cmd_TryAll4(void) {
    int i;
    if (P.totaltiles > N || P.t[0].width > M || P.t[0].height > M) {
	show_message("Only possible for <= 32 tiles in max. 128x128");
	return;	/* due to bitmap */
    }
    for (i = 1; i <= P.totaltiles; ++i) {
	arr[i-1].w = P.t[P.position[i].tilenr].width;
	arr[i-1].h = P.t[P.position[i].tilenr].height;
	arr[i-1].mx = P.t[0].width - arr[i-1].w;
	arr[i-1].my = P.t[0].height - arr[i-1].h;
	arr[i-1].cx = arr[i-1].cy = 0;
    }
    arr[0].mx = (arr[0].mx+1) / 2;
    arr[0].my = (arr[0].my+1) / 2;
    widest = 0;
    if (!setjmp(jbuf))
	try_recursive(0);
    show_message("%d tiles placed", widest);
}
